<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
<!-- 2021-12-03 Fri 15:43 -->
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1" />
<title>Xargs</title>
<meta name="author" content="dt" />
<meta name="description" content="Knowledge Base - xargs
Header
Header" />
<meta name="generator" content="Org Mode" />
<style>
  #content { max-width: 60em; margin: auto; }
  .title  { text-align: center;
             margin-bottom: .2em; }
  .subtitle { text-align: center;
              font-size: medium;
              font-weight: bold;
              margin-top:0; }
  .todo   { font-family: monospace; color: red; }
  .done   { font-family: monospace; color: green; }
  .priority { font-family: monospace; color: orange; }
  .tag    { background-color: #eee; font-family: monospace;
            padding: 2px; font-size: 80%; font-weight: normal; }
  .timestamp { color: #bebebe; }
  .timestamp-kwd { color: #5f9ea0; }
  .org-right  { margin-left: auto; margin-right: 0px;  text-align: right; }
  .org-left   { margin-left: 0px;  margin-right: auto; text-align: left; }
  .org-center { margin-left: auto; margin-right: auto; text-align: center; }
  .underline { text-decoration: underline; }
  #postamble p, #preamble p { font-size: 90%; margin: .2em; }
  p.verse { margin-left: 3%; }
  pre {
    border: 1px solid #e6e6e6;
    border-radius: 3px;
    background-color: #f2f2f2;
    padding: 8pt;
    font-family: monospace;
    overflow: auto;
    margin: 1.2em;
  }
  pre.src {
    position: relative;
    overflow: auto;
  }
  pre.src:before {
    display: none;
    position: absolute;
    top: -8px;
    right: 12px;
    padding: 3px;
    color: #555;
    background-color: #f2f2f299;
  }
  pre.src:hover:before { display: inline; margin-top: 14px;}
  /* Languages per Org manual */
  pre.src-asymptote:before { content: 'Asymptote'; }
  pre.src-awk:before { content: 'Awk'; }
  pre.src-authinfo::before { content: 'Authinfo'; }
  pre.src-C:before { content: 'C'; }
  /* pre.src-C++ doesn't work in CSS */
  pre.src-clojure:before { content: 'Clojure'; }
  pre.src-css:before { content: 'CSS'; }
  pre.src-D:before { content: 'D'; }
  pre.src-ditaa:before { content: 'ditaa'; }
  pre.src-dot:before { content: 'Graphviz'; }
  pre.src-calc:before { content: 'Emacs Calc'; }
  pre.src-emacs-lisp:before { content: 'Emacs Lisp'; }
  pre.src-fortran:before { content: 'Fortran'; }
  pre.src-gnuplot:before { content: 'gnuplot'; }
  pre.src-haskell:before { content: 'Haskell'; }
  pre.src-hledger:before { content: 'hledger'; }
  pre.src-java:before { content: 'Java'; }
  pre.src-js:before { content: 'Javascript'; }
  pre.src-latex:before { content: 'LaTeX'; }
  pre.src-ledger:before { content: 'Ledger'; }
  pre.src-lisp:before { content: 'Lisp'; }
  pre.src-lilypond:before { content: 'Lilypond'; }
  pre.src-lua:before { content: 'Lua'; }
  pre.src-matlab:before { content: 'MATLAB'; }
  pre.src-mscgen:before { content: 'Mscgen'; }
  pre.src-ocaml:before { content: 'Objective Caml'; }
  pre.src-octave:before { content: 'Octave'; }
  pre.src-org:before { content: 'Org mode'; }
  pre.src-oz:before { content: 'OZ'; }
  pre.src-plantuml:before { content: 'Plantuml'; }
  pre.src-processing:before { content: 'Processing.js'; }
  pre.src-python:before { content: 'Python'; }
  pre.src-R:before { content: 'R'; }
  pre.src-ruby:before { content: 'Ruby'; }
  pre.src-sass:before { content: 'Sass'; }
  pre.src-scheme:before { content: 'Scheme'; }
  pre.src-screen:before { content: 'Gnu Screen'; }
  pre.src-sed:before { content: 'Sed'; }
  pre.src-sh:before { content: 'shell'; }
  pre.src-sql:before { content: 'SQL'; }
  pre.src-sqlite:before { content: 'SQLite'; }
  /* additional languages in org.el's org-babel-load-languages alist */
  pre.src-forth:before { content: 'Forth'; }
  pre.src-io:before { content: 'IO'; }
  pre.src-J:before { content: 'J'; }
  pre.src-makefile:before { content: 'Makefile'; }
  pre.src-maxima:before { content: 'Maxima'; }
  pre.src-perl:before { content: 'Perl'; }
  pre.src-picolisp:before { content: 'Pico Lisp'; }
  pre.src-scala:before { content: 'Scala'; }
  pre.src-shell:before { content: 'Shell Script'; }
  pre.src-ebnf2ps:before { content: 'ebfn2ps'; }
  /* additional language identifiers per "defun org-babel-execute"
       in ob-*.el */
  pre.src-cpp:before  { content: 'C++'; }
  pre.src-abc:before  { content: 'ABC'; }
  pre.src-coq:before  { content: 'Coq'; }
  pre.src-groovy:before  { content: 'Groovy'; }
  /* additional language identifiers from org-babel-shell-names in
     ob-shell.el: ob-shell is the only babel language using a lambda to put
     the execution function name together. */
  pre.src-bash:before  { content: 'bash'; }
  pre.src-csh:before  { content: 'csh'; }
  pre.src-ash:before  { content: 'ash'; }
  pre.src-dash:before  { content: 'dash'; }
  pre.src-ksh:before  { content: 'ksh'; }
  pre.src-mksh:before  { content: 'mksh'; }
  pre.src-posh:before  { content: 'posh'; }
  /* Additional Emacs modes also supported by the LaTeX listings package */
  pre.src-ada:before { content: 'Ada'; }
  pre.src-asm:before { content: 'Assembler'; }
  pre.src-caml:before { content: 'Caml'; }
  pre.src-delphi:before { content: 'Delphi'; }
  pre.src-html:before { content: 'HTML'; }
  pre.src-idl:before { content: 'IDL'; }
  pre.src-mercury:before { content: 'Mercury'; }
  pre.src-metapost:before { content: 'MetaPost'; }
  pre.src-modula-2:before { content: 'Modula-2'; }
  pre.src-pascal:before { content: 'Pascal'; }
  pre.src-ps:before { content: 'PostScript'; }
  pre.src-prolog:before { content: 'Prolog'; }
  pre.src-simula:before { content: 'Simula'; }
  pre.src-tcl:before { content: 'tcl'; }
  pre.src-tex:before { content: 'TeX'; }
  pre.src-plain-tex:before { content: 'Plain TeX'; }
  pre.src-verilog:before { content: 'Verilog'; }
  pre.src-vhdl:before { content: 'VHDL'; }
  pre.src-xml:before { content: 'XML'; }
  pre.src-nxml:before { content: 'XML'; }
  /* add a generic configuration mode; LaTeX export needs an additional
     (add-to-list 'org-latex-listings-langs '(conf " ")) in .emacs */
  pre.src-conf:before { content: 'Configuration File'; }

  table { border-collapse:collapse; }
  caption.t-above { caption-side: top; }
  caption.t-bottom { caption-side: bottom; }
  td, th { vertical-align:top;  }
  th.org-right  { text-align: center;  }
  th.org-left   { text-align: center;   }
  th.org-center { text-align: center; }
  td.org-right  { text-align: right;  }
  td.org-left   { text-align: left;   }
  td.org-center { text-align: center; }
  dt { font-weight: bold; }
  .footpara { display: inline; }
  .footdef  { margin-bottom: 1em; }
  .figure { padding: 1em; }
  .figure p { text-align: center; }
  .equation-container {
    display: table;
    text-align: center;
    width: 100%;
  }
  .equation {
    vertical-align: middle;
  }
  .equation-label {
    display: table-cell;
    text-align: right;
    vertical-align: middle;
  }
  .inlinetask {
    padding: 10px;
    border: 2px solid gray;
    margin: 10px;
    background: #ffffcc;
  }
  #org-div-home-and-up
   { text-align: right; font-size: 70%; white-space: nowrap; }
  textarea { overflow-x: auto; }
  .linenr { font-size: smaller }
  .code-highlighted { background-color: #ffff00; }
  .org-info-js_info-navigation { border-style: none; }
  #org-info-js_console-label
    { font-size: 10px; font-weight: bold; white-space: nowrap; }
  .org-info-js_search-highlight
    { background-color: #ffff00; color: #000000; font-weight: bold; }
  .org-svg { width: 90%; }
</style>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
</head>
<body>
<div id="content" class="content">
<h1 class="title">Xargs</h1>
<div id="table-of-contents" role="doc-toc">
<h2>Table of Contents</h2>
<div id="text-table-of-contents" role="doc-toc">
<ul>
<li><a href="#org9d083f9">What is xargs?</a></li>
<li><a href="#org13ba8ae">Examples</a>
<ul>
<li><a href="#org0467901">Run a command using the input data as arguments:</a></li>
<li><a href="#org697bcc8">Run multiple chained commands on the input data:</a></li>
<li><a href="#org81f23a5">Take output from cat and create an argument list</a></li>
<li><a href="#org4de9220">Generate a compact list of all Linux user accounts on the system</a></li>
<li><a href="#orge0c2e5b">ls example</a></li>
<li><a href="#org451a252">Make 1000 sequential .txt files</a></li>
<li><a href="#org447fecb">Mkdir</a></li>
<li><a href="#org527becd">Find</a>
<ul>
<li><a href="#org3c7e56a">Footer</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<table border="2" cellspacing="0" cellpadding="6" rules="groups" frame="hsides">


<colgroup>
<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />
</colgroup>
<tbody>
<tr>
<td class="org-left"><a href="../index.html">Home</a></td>
<td class="org-left"><a href="../dtos/index.html">DTOS</a></td>
<td class="org-left"><a href="index.html">Knowledge Base</a></td>
<td class="org-left"><a href="../community/index.html">Community</a></td>
<td class="org-left"><a href="../contribute/index.html">Contribute</a></td>
<td class="org-left"><a href="../support/index.html">Support DT&rsquo;s Work</a></td>
</tr>
</tbody>
</table>

<div id="outline-container-org9d083f9" class="outline-2">
<h2 id="org9d083f9">What is xargs?</h2>
<div class="outline-text-2" id="text-org9d083f9">
<p>
Execute a command with piped arguments coming from another command, a file, etc. The input is treated as a single block of text and split into separate pieces on spaces, tabs, newlines and end-of-file.
</p>

<p>
The xargs command in UNIX is a command line utility for building an execution pipeline from standard input. Whilst tools like grep can accept standard input as a parameter, many other tools cannot. Using xargs allows tools like echo and rm and mkdir to accept standard input as arguments.
</p>
</div>
</div>

<div id="outline-container-org13ba8ae" class="outline-2">
<h2 id="org13ba8ae">Examples</h2>
<div class="outline-text-2" id="text-org13ba8ae">
</div>
<div id="outline-container-org0467901" class="outline-3">
<h3 id="org0467901">Run a command using the input data as arguments:</h3>
<div class="outline-text-3" id="text-org0467901">
<pre class="example" id="org02ea029">
arguments_source | xargs command
</pre>
</div>
</div>

<div id="outline-container-org697bcc8" class="outline-3">
<h3 id="org697bcc8">Run multiple chained commands on the input data:</h3>
<div class="outline-text-3" id="text-org697bcc8">
<pre class="example" id="org6dea724">
arguments_source | xargs sh -c "command1 &amp;&amp; command2 | command3"
</pre>
</div>
</div>


<div id="outline-container-org81f23a5" class="outline-3">
<h3 id="org81f23a5">Take output from cat and create an argument list</h3>
<div class="outline-text-3" id="text-org81f23a5">
<pre class="example" id="orgf429086">
cat list | xargs
</pre>

<p>
Wait!  I thought xargs took output from command and passed it into another command.  So what command is xargs using here?
</p>

<p>
<code>The -t flag</code>
</p>
<pre class="example" id="org73851e8">
cat list | xargs -t
</pre>
<p>
You will see that xargs uses echo since we didn&rsquo;t specify another command.
</p>

<p>
<code>The -n flag</code>
</p>
<pre class="example" id="org227267c">
cat list | xargs -t -n 1
</pre>
<p>
It echos them one at a time now instead of a single echo.
</p>
</div>
</div>

<div id="outline-container-org4de9220" class="outline-3">
<h3 id="org4de9220">Generate a compact list of all Linux user accounts on the system</h3>
<div class="outline-text-3" id="text-org4de9220">
<pre class="example" id="org9c5d4b4">
cut -d: -f1 &lt; /etc/passwd | sort | xargs
</pre>
</div>
</div>


<div id="outline-container-orge0c2e5b" class="outline-3">
<h3 id="orge0c2e5b">ls example</h3>
<div class="outline-text-3" id="text-orge0c2e5b">
<pre class="example" id="org7eeed2a">
/bin/ls
/bin/ls | xargs ls
</pre>

<p>
<code>the -I flag</code>
The braces symbolize all the input
</p>
<pre class="example" id="orgdd013b8">
ls | xargs -I {} echo "/home/dt/{}"
</pre>

<p>
The X&rsquo;s symbolize all the input
</p>
<pre class="example" id="org44acf24">
ls | xargs -I XXXX echo "/home/dt/XXXX"
</pre>
</div>
</div>

<div id="outline-container-org451a252" class="outline-3">
<h3 id="org451a252">Make 1000 sequential .txt files</h3>
<div class="outline-text-3" id="text-org451a252">
<pre class="example" id="orga4cdf50">
seq 1000 | xargs -I {} touch {}.txt
</pre>

<p>
<code>convoluted example</code>
</p>
<pre class="example" id="orgf43fbf0">
/bin/ls | cut -d. -f1 | grep -v list | xargs -I {} mv {}.txt {}.text
</pre>
</div>
</div>

<div id="outline-container-org447fecb" class="outline-3">
<h3 id="org447fecb">Mkdir</h3>
<div class="outline-text-3" id="text-org447fecb">
<pre class="example" id="orgb092c0a">
echo 'one two three' | xargs mkdir
ls
one two three
</pre>

<p>
When filenames contains spaces you need to use -d option to change delimiter
touch &rsquo;test file&rsquo;
</p>
<pre class="example" id="org8fd72b1">
/bin/ls | xargs -n 1
</pre>
<p>
test and file are on their own lines&#x2026;not good!
</p>

<pre class="example" id="org5b7943d">
/bin/ls | xargs -n 1 -d \n
</pre>
<p>
Sets new lines as delimiter and now output is good.
</p>
</div>
</div>

<div id="outline-container-org527becd" class="outline-3">
<h3 id="org527becd">Find</h3>
<div class="outline-text-3" id="text-org527becd">
<p>
Delete all files with a `.backup` extension (`-print0` uses a null character to split file names, and `-0` uses it as delimiter):
</p>
<pre class="example" id="orge3da120">
find . -name '*.backup' -print0 | xargs -0 rm -v
</pre>
<p>
Rm files older than two weeks in the /tmp folder
</p>
<pre class="example" id="org639e9c0">
find /tmp -mtime +14 | xargs rm
</pre>
<p>
xargs vs exec
The find command supports the -exec option that allows arbitrary commands to be performed on found files. The following are equivalent.
</p>

<pre class="example" id="org00814b0">
find foo -type f -name "*.txt" -exec rm {} \;
find foo -type f -name "*.txt" | xargs rm
</pre>

<p>
So which one is faster? Let’s compare a folder with 1000 files in it.
</p>

<pre class="example" id="org4de5fe1">
time find . -type f -name "*.txt" -exec rm {} \;
0.35s user 0.11s system 99% cpu 0.467 total

time find . -type f -name "*.txt" | xargs rm
0.00s user 0.01s system 75% cpu 0.016 total
</pre>

<p>
Clearly using xargs is far more efficient. In fact several benchmarks suggest using xargs over exec {} is six times more efficient.
</p>

<p>
Parallel runs of up to `max-procs` processes at a time; the default is 1. If `max-procs` is 0, xargs will run as many processes as possible at a time:
</p>
<pre class="example" id="orgc799472">
arguments_source | xargs -P max-procs command
seq 5 | xargs -n 1 -P 1 bash -c 'echo $0; sleep 1'
</pre>
</div>

<div id="outline-container-org3c7e56a" class="outline-4">
<h4 id="org3c7e56a">Footer</h4>
<div class="outline-text-4" id="text-org3c7e56a">
<p>
Copyright © 2020-2021 Derek Taylor (DistroTube)
</p>

<p>
This page is licensed under a <a href="https://creativecommons.org/licenses/by-nd/4.0/">Creative Commons Attribution-NoDerivatives 4.0 International License</a> (CC-BY-ND 4.0).
</p>

<p>
The source code for distro.tube can be found on <a href="https://gitlab.com/dwt1/distro.tube">GitLab</a>.  User-submitted contributions to the site are welcome, as long as the contributor agrees to license their submission with the CC-BY-ND 4.0 license.
</p>
</div>
</div>
</div>
</div>
</div>
<div id="postamble" class="status">
<p class="author">Author: dt</p>
<p class="date">Created: 2021-12-03 Fri 15:43</p>
</div>
</body>
</html>
